searchData={"items":[{"type":"module","title":"AshCloak","doc":"An extension for encrypting attributes of a resource.\n\nSee the getting started guide for more information.","ref":"AshCloak.html"},{"type":"macro","title":"AshCloak.cloak/1","doc":"","ref":"AshCloak.html#cloak/1"},{"type":"function","title":"AshCloak.encrypt_and_set/3","doc":"Encrypts and writes to an encrypted attribute.\n\nIf the changeset is pending (i.e not currently running the action), then it is added as a before_action hook.\nOtherwise, it is run immediately\n\nRaises AshCloak.Errors.NoSuchEncryptedAttribute if the attribute is not configured for encryption.","ref":"AshCloak.html#encrypt_and_set/3"},{"type":"module","title":"AshCloak.Changes.Encrypt","doc":"Takes an argument, and encrypts it into an attribute called `encrypted_{attribute}`","ref":"AshCloak.Changes.Encrypt.html"},{"type":"function","title":"AshCloak.Changes.Encrypt.atomic/3","doc":"","ref":"AshCloak.Changes.Encrypt.html#atomic/3"},{"type":"function","title":"AshCloak.Changes.Encrypt.change/3","doc":"","ref":"AshCloak.Changes.Encrypt.html#change/3"},{"type":"module","title":"AshCloak.Info","doc":"Introspection functions for the `AshCloak` extension.","ref":"AshCloak.Info.html"},{"type":"function","title":"AshCloak.Info.cloak_attributes/1","doc":"The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added.","ref":"AshCloak.Info.html#cloak_attributes/1"},{"type":"function","title":"AshCloak.Info.cloak_attributes!/1","doc":"The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added.","ref":"AshCloak.Info.html#cloak_attributes!/1"},{"type":"function","title":"AshCloak.Info.cloak_decrypt_by_default/1","doc":"A list of attributes that should be decrypted (their calculation should be loaded) by default.","ref":"AshCloak.Info.html#cloak_decrypt_by_default/1"},{"type":"function","title":"AshCloak.Info.cloak_decrypt_by_default!/1","doc":"A list of attributes that should be decrypted (their calculation should be loaded) by default.","ref":"AshCloak.Info.html#cloak_decrypt_by_default!/1"},{"type":"function","title":"AshCloak.Info.cloak_on_decrypt/1","doc":"A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}`","ref":"AshCloak.Info.html#cloak_on_decrypt/1"},{"type":"function","title":"AshCloak.Info.cloak_on_decrypt!/1","doc":"A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}`","ref":"AshCloak.Info.html#cloak_on_decrypt!/1"},{"type":"function","title":"AshCloak.Info.cloak_options/1","doc":"cloak DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshCloak.Info.html#cloak_options/1"},{"type":"function","title":"AshCloak.Info.cloak_vault/1","doc":"The vault to use to encrypt & decrypt the value","ref":"AshCloak.Info.html#cloak_vault/1"},{"type":"function","title":"AshCloak.Info.cloak_vault!/1","doc":"The vault to use to encrypt & decrypt the value","ref":"AshCloak.Info.html#cloak_vault!/1"},{"type":"exception","title":"AshCloak.Errors.NoSuchEncryptedAttribute","doc":"An error raised when attempting to decrypt an attribute that is not encrypted.","ref":"AshCloak.Errors.NoSuchEncryptedAttribute.html"},{"type":"function","title":"AshCloak.Errors.NoSuchEncryptedAttribute.exception/1","doc":"Create an `Elixir.AshCloak.Errors.NoSuchEncryptedAttribute` without raising it.","ref":"AshCloak.Errors.NoSuchEncryptedAttribute.html#exception/1"},{"type":"function","title":"Keys - AshCloak.Errors.NoSuchEncryptedAttribute.exception/1","doc":"- :key\n- :resource","ref":"AshCloak.Errors.NoSuchEncryptedAttribute.html#exception/1-keys"},{"type":"extras","title":"Home","doc":"![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-black-text.png?raw=true#gh-light-mode-only)\n![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-white-text.png?raw=true#gh-dark-mode-only)\n\n![Elixir CI](https://github.com/ash-project/ash_cloak/workflows/CI/badge.svg)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ash_cloak.svg)](https://hex.pm/packages/ash_cloak)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ash_cloak)\n\n# AshCloak\n\nAshCloak is an [Ash](https://hexdocs.pm/ash) extension to seamlessly encrypt and decrypt attributes of your resources.\n\nEncrypting attributes ensures that sensitive fields are not stored in the clear in your data layer.\n\nAshCloak can be used with any Ash data layer.\n\nIt's recommended to use [Cloak](https://github.com/danielberkompas/cloak) as a vault implementation but you could also build your own.","ref":"readme.html"},{"type":"extras","title":"Tutorials - Home","doc":"- [Get Started with AshCloak](documentation/tutorials/getting-started-with-ash-cloak.md)","ref":"readme.html#tutorials"},{"type":"extras","title":"Topics - Home","doc":"- [How does AshCloak work?](documentation/topics/how-does-ash-cloak-work.md)","ref":"readme.html#topics"},{"type":"extras","title":"Reference - Home","doc":"- [AshCloak DSL](documentation/dsls/DSL-AshCloak.md)","ref":"readme.html#reference"},{"type":"extras","title":"Get Started with AshCloak","doc":"# Get Started with AshCloak","ref":"getting-started-with-ash-cloak.html"},{"type":"extras","title":"Installation - Get Started with AshCloak","doc":"Add `ash_cloak` to your list of dependencies in `mix.exs`:\n\n```elixir\n{:ash_cloak, \"~> 0.1.5\"}\n```\n\nFollow [the cloak getting started guide](https://hexdocs.pm/cloak/readme.html) to add `cloak` as a dependency, as AshCloak does not add a vault implementation for you. Note that you do not need `cloak_ecto` because your Ash data layer will take care of this.\n\nAlternatively you could use your own vault module that implements `encrypt!` and `decrypt!`, but we recommend using `Cloak` to achieve that goal. See the [cloak vault guide](https://hexdocs.pm/cloak/install.html#create-a-vault)","ref":"getting-started-with-ash-cloak.html#installation"},{"type":"extras","title":"Add the `AshCloak` extension to your resource - Get Started with AshCloak","doc":"```elixir\ndefmodule User do\n  use Ash.Resource, extensions: [AshCloak]\n\n  cloak do\n    # the vault to use to encrypt them\n    vault MyApp.Vault\n\n    # the attributes to encrypt\n    attributes [:address, :phone_number]\n    \n    # This is just equivalent to always providing `load: fields` on all calls\n    decrypt_by_default [:address]\n    \n    # An MFA or function to be invoked beforce any decryption\n    on_decrypt fn records, field, context ->\n      # Ash has policies that allow forbidding certain users to load data.\n      # You should generally use those for authorization rules, and\n      # only use this callback for auditing/logging.\n      Audit.user_accessed_encrypted_field(records, field, context)\n\n      if context.user.name == \"marty\" do\n        {:error, \"No martys at the party!\"}\n      else\n        :ok\n      end\n    end\n  end\nend\n```","ref":"getting-started-with-ash-cloak.html#add-the-ashcloak-extension-to-your-resource"},{"type":"extras","title":"How does AshCloak work?","doc":"# How does AshCloak work?","ref":"how-does-ash-cloak-work.html"},{"type":"extras","title":"Rewrite attributes to calculations - How does AshCloak work?","doc":"First, AshCloak changes the name of each cloaked attribute to `encrypted_ `, and sets `public?: false` and `sensitive?: true`.\n\nThen it adds a _calculation_ matching the original attribute that, when loaded, will decrypt the given attribute and call any configured `on_decrypt` callbacks.","ref":"how-does-ash-cloak-work.html#rewrite-attributes-to-calculations"},{"type":"extras","title":"Modify Actions - How does AshCloak work?","doc":"AshCloak then goes through each action that accepts the attribute and removes the attribute from the accept list.\n\nThen it adds an argument by the same name, and a `change` that encrypts the attribute value.\n\nThis `change` also deletes the argument from the arguments list and from the params. This is a small extra layer of security to prevent accidental leakage of the value.","ref":"how-does-ash-cloak-work.html#modify-actions"},{"type":"extras","title":"Add `preparation` and `change` - How does AshCloak work?","doc":"Finally, it add a `preparation` and a `change` that will automatically load the corresponding calculations for any attribute in the `decrypt_by_default` list.","ref":"how-does-ash-cloak-work.html#add-preparation-and-change"},{"type":"extras","title":"The result - How does AshCloak work?","doc":"The cloaked attribute will now seamlessly encrypt when writing and decrypt on request.","ref":"how-does-ash-cloak-work.html#the-result"},{"type":"DSL","title":"cloak - dsl-ashcloak","doc":"Encrypt attributes of a resource","ref":"dsl-ashcloak.html#cloak"},{"type":"DSL","title":"cloak.vault - dsl-ashcloak","doc":"The vault to use to encrypt & decrypt the value","ref":"dsl-ashcloak.html#cloak-vault"},{"type":"DSL","title":"cloak.attributes - dsl-ashcloak","doc":"The attribute or attributes to encrypt. The attribute will be renamed to `encrypted_{attribute}`, and a calculation with the same name will be added.","ref":"dsl-ashcloak.html#cloak-attributes"},{"type":"DSL","title":"cloak.decrypt_by_default - dsl-ashcloak","doc":"A list of attributes that should be decrypted (their calculation should be loaded) by default.","ref":"dsl-ashcloak.html#cloak-decrypt_by_default"},{"type":"DSL","title":"cloak.on_decrypt - dsl-ashcloak","doc":"A function to call when decrypting any value. Takes the resource, field, records, and calculation context. Must return `:ok` or `{:error, error}`","ref":"dsl-ashcloak.html#cloak-on_decrypt"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.1.5](https://github.com/ash-project/ash_cloak/compare/v0.1.4...v0.1.5) (2025-03-11)","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* Apply default of attribute to argument (#80)\n\n## [v0.1.4](https://github.com/ash-project/ash_cloak/compare/v0.1.3...v0.1.4) (2025-02-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* return `{:ok, changeset}` to do nothing on encryption change\n\n## [v0.1.3](https://github.com/ash-project/ash_cloak/compare/v0.1.2...v0.1.3) (2025-01-27)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* encrypt attribute when not listed on `accept` list (#46)\n\n## [v0.1.2](https://github.com/ash-project/ash_cloak/compare/v0.1.1...v0.1.2) (2024-08-19)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add atomic implementation for `AshCloack.Changes.Encrypt`\n\n## [v0.1.1](https://github.com/ash-project/ash_cloak/compare/v0.1.0...v0.1.1) (2024-08-02)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- [`AshCloak.Changes.Encrypt`] run encrypt on before_action (#14)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [`AshCloak`] add `AshCloak.encrypt_and_set/3`\n\n## [v0.1.0](https://github.com/ash-project/ash_cloak/compare/v0.1.0-rc.0...v0.1.0) (2024-05-11)\n\n## [v0.1.0-rc.0](https://github.com/ash-project/ash_cloak/compare/v0.1.0...v0.1.0) (2024-04-25)\n\nInitial feature set","ref":"changelog.html#improvements"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}